#include <hmg.ch>

Function Main
   private oGridGraph, oColumnGraph, oHMGColumn, oHMGPoints, oHMGLine, oHMGPie
   aData := { { 'January', '15000', '2500' }, { 'February', '14000', '2800' },;
                        { 'March', '10000', '-2000' },;               
                        { 'April', '16000', '3500' },;
                        { 'May', '15800', '3000' },;
                        { 'June', '16400', '4000' },;
                        { 'July', '15300', '2800' }}

   define window chart at 0, 0 width 880 height 800 title 'Chart+ Demo' main
      define tab tab1 at 10, 10 width 860 height 700
         define page 'HMG Sample Column'
            define image hmgcolumn
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'HMG Sample Points'
            define image hmgpoints
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'HMG Sample Line'
            define image hmgline
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'HMG Sample Pie'
            define image hmgpie
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Column'
            define image columnchart
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Grid Data'
            define image gridchart
               row 30
               col 30
               width 800
               height 400
            end image
            define grid data
               row 440
               col 30
               width 400
               height 180
               headers { 'Period', 'Sales', 'Profit' }
               widths { 100, 120, 120 }
               justify { 0, 1, 1 }
               items aData
               value 1                        
            end grid  
            define button switch
               row 440
               col 450
               width 180
               caption 'Switch Rows and Columns'
               action switchrows()
            end button   
         end page            
      end tab
      define button savefiles
         row 720
         col 400
         width 80
         caption 'Save All'
         action saveallfiles()
      end button   
   end window
   drawcharts()
   chart.center
   chart.activate
Return

function drawcharts
   
   // hmgcolumn
   oHMGColumn := GraphPlus():New()
   with object oHMGColumn
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :ShowLabels := .t.
      :Picture := '99,999.99'      
      :Draw()
      chart.hmgcolumn.hBitmap := :Bitmap()
   endwith
   // hmgpoints
   oHMGPoints := GraphPlus():New()
   with object oHMGPoints
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :Picture := '99,999.99' 
      :ShowLabels := .t.
      :GraphType := 3      
      :Draw()
      chart.hmgpoints.hBitmap := :Bitmap()
   endwith
   // hmgline
   oHMGLine := GraphPlus():New()
   with object oHMGLine
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :Picture := '99,999.99' 
      :ShowLabels := .t.
      :GraphType := 2      
      :Draw()
      chart.hmgline.hBitmap := :Bitmap()
   endwith
   // pie
   oHMGPie := GraphPlus():New()
   with object oHMGPie
      :GraphData := { 1500, 1800, 200, 500, 800 } 
      :Legends   := { "Product 1", "Product 2", "Product 3", "Product 4", "Product 5" }
      :ShowLegends := .t.
      :LegendPos := 0
      :Width := 800
      :Height := 600
      :Title := 'Sample Graph'
      :Picture := '99,999.99' 
      :ShowLabels := .t.
      :GraphType := 4      
      :Draw()
      chart.hmgpie.hBitmap := :Bitmap()
   endwith
   
   // columnChart
   oColumnGraph := GraphPlus():new()
   with object oColumnGraph
      :GraphData := { { -907, 2500, 3200, 4531, 1541 },;
                      { 500,700, 350, 400, 400 },;
                      { -467, 250, 540, 548, -350 },;
                      { 300, 560, 0, 57, 88 } }
      && :GraphData := { { 15907, 2500, 3200, 4531, 1541 },;
                      && { 500,700, 350, 400, 400 },;
                      && { -467, 250, 540, 548, 1050 },;
                      && { 300, 560, 4850, 57, 88 } }
      && :GraphData := { { 0.000101, 0.000302, 0.000201, 0.0004001, 0.000301 },;
                      && { 0.000151,0.000181, -0.000101, 0.0002001, -0.000401 } }
      :Picture := '99,999'
      :Legends := { 'Legend 1', 'Legend 2', 'A Big Legend 3', 'A Big Legend 4' }
      :ShowLegends := .t.
      :ColorTheme := 3
      :LegendPos := 1
      :Width := 800
      :Height := 600
      :Categories := { 'Category 1', 'Category 2', 'Category 3', 'Category 4', 'Category 5' }
      :Title := 'Chart Title'
      :XTitle := 'XTitle'
      :YTitle := 'YTitle'
      :ShowVGrid := .t.
      :ShowLabels := .t.
      :BackColor := { 0, 0, 0 }
      :Draw()
      chart.columnChart.hBitmap := :Bitmap()
   endwith
   // grid data
   oGridGraph := GraphPlus():new()
   with object oGridGraph
      :GridData( 'chart', 'data' )
      :Width := 800
      :Height := 400
      :ShowLegends := .t.
      :LegendPos := 0
      :SwitchRowstoColumns()
      :draw()
      chart.gridchart.hBitmap := :Bitmap()
   endwith   
return nil   

function switchrows
   oGridGraph:SwitchRowstoColumns()
   oGridGraph:Draw()
   chart.gridchart.hBitmap := oGridGraph:Bitmap()
return nil   

function saveallfiles
   oGridGraph:save('graphplus01.png')
   oColumnGraph:save('graphplus02.png')
   oHMGColumn:save('graphplus03.png')
   oHMGPoints:save('graphplus04.png')
   oHMGLine:save('graphplus05.png')
   oHMGPie:save('graphplus06.png')
return nil